#include <karm/interface.h>
#include "interface/block.h"
#include "interface/char.h"
#include "interface/dir.h"
#include "interface/file.h"
#include "interface/mapping.h"
#include "interface/process.h"

#define NB_ARGS_ARRAY(nb_args...) (int[]){ nb_args, -1 }

struct interface interface_array[] = {

  [INTERFACE_BLOCK_ID] = { "block" , INTERFACE_BLOCK_NB_OPS, 
			   NB_ARGS_ARRAY(4, 4, 3, 3) },
  [INTERFACE_CHAR_ID] = { "char" , INTERFACE_CHAR_NB_OPS, 
			  NB_ARGS_ARRAY(3, 3) },
  [INTERFACE_DIR_ID] = { "dir" , INTERFACE_DIR_NB_OPS, 
			 NB_ARGS_ARRAY(3) },
  [INTERFACE_FILE_ID] = { "file" , INTERFACE_FILE_NB_OPS, 
			  NB_ARGS_ARRAY(3, 3, 3) },
  [INTERFACE_MAPPING_ID] = { "mapping" , INTERFACE_MAPPING_NB_OPS, 
			     NB_ARGS_ARRAY(2, 4, 4) },
  [INTERFACE_PROCESS_ID] = { "process" , INTERFACE_PROCESS_NB_OPS, 
			     NB_ARGS_ARRAY(4, 2, 1, 4, 2, 2, 2) },
};

uint interface_array_size = 
 sizeof(interface_array) / sizeof(struct interface);
