#ifndef __BLOCK_H__
#define __BLOCK_H__

#include <karm/karm.h>
#include <kos/types.h>
#include <kos/errno.h>

#define INTERFACE_BLOCK __kos_interface_block
#define INTERFACE_BLOCK_ID     3
#define BLOCK_OPS(ops) (( struct __kos_interface_block *)(ops))

typedef enum { BLOCK_DEV_LOCK_READ, 
	       BLOCK_DEV_LOCK_WRITE, 
	       BLOCK_DEV_UNLOCK} block_lock_op_t;

struct __kos_interface_block {
  result_t (*read)(struct ures *ur, char *buffer, 
		   count_t block_start, 
		   count_t *inout_block_count);
  result_t (*write)(struct ures *ur, const char *buffer, 
		    count_t block_start, 
		    count_t *inout_block_count);
  result_t (*get_device_size)(const struct ures *ur, 
			      size_t *out_block_size, 
			      count_t *out_block_count);
  result_t (*ctrl_lock)(struct ures *ur, 
			block_lock_op_t op_type, 
			count_t block_start);
};

#define INTERFACE_BLOCK_NB_OPS \
        INTERFACE_SIZE(struct __kos_interface_block)
#endif
